'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _desc, _value, _class2, _descriptor;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAutobind = require('react-autobind');

var _reactAutobind2 = _interopRequireDefault(_reactAutobind);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _reactDatepicker = require('react-datepicker');

var _reactDatepicker2 = _interopRequireDefault(_reactDatepicker);

require('react-datepicker/dist/react-datepicker.css');

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _FilterVariantIcon = require('mdi-react/FilterVariantIcon');

var _FilterVariantIcon2 = _interopRequireDefault(_FilterVariantIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var MenuPickerOverlay = (0, _mobxReact.observer)(_class = (_class2 = function (_React$Component) {
  _inherits(MenuPickerOverlay, _React$Component);

  function MenuPickerOverlay(props) {
    _classCallCheck(this, MenuPickerOverlay);

    // this prevents problems with bad key values.  When switching frmo one grid to another in a tab frame, while the overlay is open the overlay div could stay in place, which is wrong.
    var _this = _possibleConstructorReturn(this, (MenuPickerOverlay.__proto__ || Object.getPrototypeOf(MenuPickerOverlay)).call(this, props));

    _initDefineProp(_this, 'filterText', _descriptor, _this);

    _this.semiUniqueKey = Math.random();
    (0, _reactAutobind2.default)(_this);
    return _this;
  }

  _createClass(MenuPickerOverlay, [{
    key: 'blackHole',
    value: function blackHole(evt) {}
  }, {
    key: 'changeFilter',
    value: function changeFilter(evt) {
      this.filterText = evt.target.value;
    }
  }, {
    key: 'endEdit',
    value: function endEdit() {
      this.props.GridStore.cursor.editX = -1;
      this.props.GridStore.cursor.editY = -1;
      this.props.GridStore.showMenuPicker = false;
    }
  }, {
    key: 'updateValue',
    value: function updateValue(evt, val) {
      this.props.GridStore.curEditingValue = val;
      this.props.GridStore.onChangePivotWrapper(this.props.GridStore.cursor.editX, this.props.GridStore.cursor.editY, this.props.GridStore.cursor.editObjKey, this.props.GridStore.curEditingValue);
      this.endEdit();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var editVal = this.props.GridStore.curEditingValue || '';
      var saneThis = this;

      var itemList = [];
      var listTarget = this.props.GridStore.colDefListByKey[this.props.GridStore.cursor.editObjKey].easyMenu;
      if (listTarget && listTarget.length) {
        // it's an array
        // JJH Needs a storybook test
        itemList = listTarget.map(function (item, index) {
          if ('' === _this2.filterText.trim() || ('' + item).indexOf(_this2.filterText) !== -1) {
            return _react2.default.createElement(
              'div',
              { key: 'gridMenu' + index, id: 'gridMenu' + index, style: { padding: '2px', borderBottom: '1px solid lightgrey', paddingLeft: '15px' },
                onClick: function onClick(e) {
                  return saneThis.updateValue(e, item);
                } },
              item
            );
          } else {
            return null;
          }
        });
      } else {
        // or it's a pipe delimited string
        listTarget = '' + listTarget;
        itemList = listTarget.split('|').map(function (item, index) {
          if ('' === _this2.filterText.trim() || ('' + item).indexOf(_this2.filterText) !== -1) {
            return _react2.default.createElement(
              'div',
              { key: 'gridMenu' + index, id: 'gridMenu' + index, style: { padding: '2px', borderBottom: '1px solid lightgrey', paddingLeft: '15px' },
                onClick: function onClick(e) {
                  return saneThis.updateValue(e, item);
                } },
              item
            );
          } else {
            return null;
          }
        });
      }

      return _react2.default.createElement(
        'div',
        { key: this.semiUniqueKey },
        _react2.default.createElement('div', { style: { position: 'absolute', top: '0px', bottom: '0px', left: '0px', width: this.props.uiMath.rowWide + 2 + 'px', backgroundColor: 'grey', zIndex: '20', opacity: '0.7' }, onClick: this.endEdit }),
        _react2.default.createElement(
          'div',
          { style: { position: 'absolute', top: '15px', left: '15px', width: this.props.uiMath.rowWide - 50 + 'px', height: this.props.uiMath.gridHigh - 30, zIndex: '30' } },
          _react2.default.createElement(
            'span',
            { style: { float: 'right', marginRight: '15px' } },
            _react2.default.createElement('input', { type: 'text', onChange: this.changeFilter, value: this.filterText, style: { backgroundColor: 'white' } })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { position: 'absolute', top: '15px', left: this.props.uiMath.rowWide - 70 + 'px', zIndex: '35' } },
          _react2.default.createElement(_FilterVariantIcon2.default, { width: 18, height: 18 })
        ),
        _react2.default.createElement(
          'div',
          { style: { position: 'absolute', top: '35px', left: '15px',
              width: this.props.uiMath.rowWide - 50 + 'px', height: this.props.uiMath.gridHigh - 70,
              border: '1px solid grey', borderRadius: '5px', overflow: 'hidden',
              backgroundColor: 'white', zIndex: '30' } },
          _react2.default.createElement(
            'div',
            { style: { position: 'absolute', top: '0px', left: '0px', right: '0px', bottom: '0px',
                backgroundColor: 'white', zIndex: '30', overflow: 'auto' } },
            itemList
          )
        )
      );
    }
  }]);

  return MenuPickerOverlay;
}(_react2.default.Component), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'filterText', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return '';
  }
}), _applyDecoratedDescriptor(_class2.prototype, 'changeFilter', [_mobx.action], Object.getOwnPropertyDescriptor(_class2.prototype, 'changeFilter'), _class2.prototype)), _class2)) || _class;

exports.default = MenuPickerOverlay;
module.exports = exports['default'];